#include <string.h> 
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <3ds.h>
#include "archive.h"

typedef int (*menuent_funcptr)(void);

int menu_300coins();
int setcoins(u8 highByte, u8 lowByte);
u8 *filebuffer;
u32 filebuffer_maxsize = 0x400000;

int menu_300coins()
{
	return setcoins(0x01, 0x2C);
}

int setcoins(u8 highByte, u8 lowByte)
{	
	Result ret=0;

	printf("Plundering Mushroom Kingdom for 300 more coins...\n");
	gfxFlushBuffers();
	gfxSwapBuffers();

	ret = archive_readfile(GameCoin_Extdata, "/gamecoin.dat", filebuffer, 0x14);
	if(ret!=0)
	{
		printf("Failed to read file: 0x%08x\n", (unsigned int)ret);
		gfxFlushBuffers();
		gfxSwapBuffers();
		return 0;
	}

	filebuffer[0x4]=lowByte;
	filebuffer[0x5]=highByte;
	gfxFlushBuffers();
	gfxSwapBuffers();

	ret = archive_writefile(GameCoin_Extdata, "/gamecoin.dat", filebuffer, 0x14);
	printf("\n\nSuccess! 300 coin get!\nBack to Home Menu...");
	if(ret!=0)
	{
		printf("Failed to write file: 0x%08x\n", (unsigned int)ret);
		gfxFlushBuffers();
		gfxSwapBuffers();
	}
	return 0;
}

int main()
{
	Result ret = 0;

	// Initialize services
	gfxInitDefault();
	consoleInit(GFX_TOP, NULL);

	printf("Quick300 Coinsetter 3DS - by MrCheeze\n\n");
	gfxFlushBuffers();
	gfxSwapBuffers();

	filebuffer = (u8*)malloc(0x400000);
	if(filebuffer==NULL)
	{
		printf("Failed to allocate memory.\n");
		gfxFlushBuffers();
		gfxSwapBuffers();
		ret = -1;
	}
	else
	{
		memset(filebuffer, 0, filebuffer_maxsize);
	}

	if(ret>=0)
	{
		printf("Opening extdata archives...\n");
		gfxFlushBuffers();
		gfxSwapBuffers();
		ret = open_extdata();
		if(ret==0)
		{
			printf("Finished opening extdata.\n");
			gfxFlushBuffers();
			gfxSwapBuffers();

			//consoleClear();
			menu_300coins();
		}
	}
	free(filebuffer);
	close_extdata();

	// Exit services
	gfxExit();
	return 0;
}